Loading...
Searching...
No Matches
casacore::MeasTable Class Reference
measures package (libcasa_measures) » Measures_module » Measures_module_internal_classes

More...

`#include <MeasTable.h>`

## Classes

struct | Statics_dUTC
| Calculate time related conversion data. More...

## Public Types

enum | Types { MERCURY , VENUS , EARTH , MARS , JUPITER , SATURN , URANUS , NEPTUNE , PLUTO , MOON , SUN , BARYSOLAR , BARYEARTH , NUTATION , LIBRATION , N_Types }
| Types to be used in different calls. More...
enum | JPLconst { CAU , GMS , AU , RADS , N_JPLconst }
| Codes for JPL constants: order should be same as in MeasJPL, length less than or equal. More...

## Static Public Member Functions

static Bool | useIAU2000 ()
| Selection related data.
static Bool | useIAU2000A ()
| If IAU2000 model, do we use the high precision 2000A model?
static Double | precRate00 (const uInt which)
| Precession related data.
static RotMatrix | frameBias00 ()
| Get the frame bias matrix for IAU2000 model.
static void | precessionCoef (Double T, Polynomial< Double > result[3])
| Generate the precession calculation polynomials for a fixed Epoch T in the result area specified.
static void | precessionCoef2000 (Polynomial< Double > result[3])
| Generate the precession polynomials for IAU2000 system.
static void | precessionCoef1950 (Double T, Polynomial< Double > result[3])
| Generate the precession polynomials for 1950 system for a fixed Epoch T in the area specified.
static const Polynomial< Double > & | fundArg (uInt which)
| Nutation related data.
static const Polynomial< Double > & | fundArg1950 (uInt which)
static const Polynomial< Double > & | fundArg2000 (uInt which)
static const Polynomial< Double > & | planetaryArg2000 (uInt which)
| Get the planetary arguments (L, L', F, D, Om, Me, Ve, E, Ma, Ju Sa, Ur, Ne, pre).
static const Double * | mulArg (uInt which)
| Generate the which' vector of the nutation series arguments.
static const Double * | mulArg1950 (uInt which)
static const Double * | mulArg2000A (uInt which)
static const Double * | mulArg2000B (uInt which)
static const Double * | mulPlanArg2000A (uInt which)
static const Double * | mulArgEqEqCT2000 (uInt which)
| Generate the which' vector of the equation of equinoxes (IAU2000) complementary terms series arguments.
static std::shared_ptr< Matrix< Double > > | mulSC (Double time, Double epsilon)
| Generate the which' vector of the nutation series multipliers at T, measured in Julian centuries since J2000.0, respectively B1900.0.
static std::shared_ptr< Matrix< Double > > | mulSC1950 (Double time, Double epsilon)
static std::shared_ptr< Matrix< Double > > | mulSC2000A (Double time, Double epsilon)
static std::shared_ptr< Matrix< Double > > | mulSC2000B (Double time, Double epsilon)
static const Double * | mulPlanSC2000A (uInt which)
static const Double * | mulSCEqEqCT2000 (uInt which)
| Generate the which' vector of the equation of equinoxes (IAU2000) complementary terms series multipliers at T, measured in Julian centuries since J2000.0, respectively B1900.0.
static Double | dPsiEps (uInt which, Double T)
| Get nutation angles corrections for UTC T in rad.
static Vector< Double > | Planetary (MeasTable::Types which, Double T)
| Planetary (JPL DE) related data.
static Double | Planetary (MeasTable::JPLconst what)
| Get the JPL DE constant indicated.
static void | initObservatories ()
| Observatory positions.
static const Vector< String > & | Observatories ()
| Get list of all observatories.
static Bool | Observatory (MPosition &obs, const String &nam)
| Get position of observatory nam (False if not present).
static Bool | AntennaResponsesPath (String &antRespPath, const String &nam)
| Get absolute path to AntennaResponses table of observatory nam.
static void | initSources ()
| Source list positions.
static const Vector< String > & | Sources ()
| Get list of all sources.
static Bool | Source (MDirection &obs, const String &nam)
| Get position of source nam (False if not present).
static void | initLines ()
| Rest frequencies.
static const Vector< String > & | Lines ()
| Get list of all frequencies.
static Bool | Line (MFrequency &obs, const String &nam)
| Get frequency of line name (False if not present).
static void | initIGRF ()
| Initialise list of IGRF data Called using theirIGRFInitOnce.
static Vector< Double > | IGRF (Double t)
| Earth magnetic field (IGRF) data Get the harmonic terms for specified time (mjd).
static const Polynomial< Double > & | aberArg (uInt which)
| Aberration related data.
static const Polynomial< Double > & | aberArgDeriv (uInt which)
static const Polynomial< Double > & | aber1950Arg (uInt which)
static const Polynomial< Double > & | aber1950ArgDeriv (uInt which)
static const Double * | mulAberArg (uInt which)
| Generate the 'which' vector of the aberration series arguments.
static const Double * | mulAber1950Arg (uInt which)
static const Double * | mulAberSunArg (uInt which)
static const Double * | mulAberEarthArg (uInt which)
static std::shared_ptr< Matrix< Double > > | mulAber (Double time, Double epsilon)
| Generate the 'which' vector of the aberration series multipliers at T, measured in Julian centuries since J2000.0 (or J1900.0, yes, J1900.0, for B1950).
static std::shared_ptr< Matrix< Double > > | mulAber1950 (Double time, Double epsilon)
static const Vector< Double > & | mulSunAber (uInt which)
static const Vector< Double > & | mulEarthAber (uInt which)
static const Vector< Double > & | AberETerm (uInt which)
| Get the E-terms of Aberration correction (0 for position, 1 for velocity).
static Double | diurnalAber (Double radius, Double T)
| Diurnal aberration factor.
static const Vector< Double > & | velocityLSRK (uInt which)
| LSR (kinematical) velocity conversion: 0 gives J2000; 1 gives B1950.
static const Vector< Double > & | velocityLSR (uInt which)
| LSR (dynamical, IAU definition).
static const Vector< Double > & | velocityLSRGal (uInt which)
| Velocity of LSR with respect to galactic centre.
static const Vector< Double > & | velocityCMB (uInt which)
| Velocity of Local Group wrt bary center (F.Ghigo): 308km/s towards l,b = 105,-7.
static const Vector< Double > & | velocityLGROUP (uInt which)
| Velocity of CMB wrt bary center (F.Ghigo): 369.5km/s towards l,b = 264.4,48.4.
static const Polynomial< Double > & | posArg (uInt which)
| Earth and Sun position related data.
static const Polynomial< Double > & | posArgDeriv (uInt which)
| Precomputed derivative of PosArg.
static const Double * | mulPosEarthXYArg (uInt which)
| Generate the which' vector of the position series arguments.
static const Double * | mulPosEarthZArg (uInt which)
static const Double * | mulPosSunXYArg (uInt which)
static const Double * | mulPosSunZArg (uInt which)
static std::shared_ptr< Matrix< Double > > | mulPosEarthXY (Double time, Double epsilon)
| Generate the which' vector of the position series multipliers at T, measured in Julian centuries since J2000.0.
static std::shared_ptr< Matrix< Double > > | mulPosEarthZ (Double time, Double epsilon)
static std::shared_ptr< Matrix< Double > > | mulPosSunXY (Double time, Double epsilon)
static std::shared_ptr< Matrix< Double > > | mulPosSunZ (Double time, Double epsilon)
static const RotMatrix & | posToRect ()
| Get the rotation matrix to change position from ecliptic to rectangular for Soma et al.
static const RotMatrix & | rectToPos ()
| Get the rotation matrix to change position from rectangular to ecliptic for Soma et al.
static const RotMatrix & | galToSupergal ()
| Get the rotation matrix from galactic to supergalactic.
static const RotMatrix & | ICRSToJ2000 ()
| Get the rotation matrix from ICRS to J2000/FK5.
static Double | WGS84 (uInt which)
| Position related routines.
static Euler | polarMotion (Double ut)
| Polar motion related routines.
static Double | dUTC (Double utc)
| Time related routines Note: WARNING given if correction not obtainable .
static Double | dUT1 (Double utc)
| UT1-UTC (in s) for MJD tai TAI.
static Double | dTAI (Double tai=0.0)
| TDT-TAI (in s) for MJD tai TAI.
static Double | dTDT (Double ut1)
| TDB-TDT (in s) for MJD ut1 UT1.
static Double | dTDB (Double tai)
| TCB-TDB (in s) for MJD tai TAI.
static Double | dTCG (Double tai)
| TCG-TT (in s) for MJD tai TAI.
static Double | GMST0 (Double ut1)
| GMST1 at MJD ut1 UT1.
static Double | GMST00 (Double ut1, Double tt)
| GMST (IAU2000) including the ERA (IAU2000 Earth Rotation Angle) in rad.
static Double | ERA00 (Double ut1)
| Earth Rotation Angle (IAU2000) in rad.
static Double | sprime00 (Double tt)
| s' (IAU2000) in rad (approximate value)
static Double | GMUT0 (Double gmst1)
| UT1 at GMSD gmst1 GMST1.
static Double | UTtoST (Double ut1)
| Ratio UT1/MST at MJD ut1 UT1.

## Private Member Functions

MeasTable & | operator= (const MeasTable &other)
| Copy assign, NOT defined.

## Static Private Member Functions

static void | doInitObservatories ()
static void | doInitLines ()
static void | doInitSources ()
static void | doInitIGRF ()
static void | calcPrecesCoef (Double T, Polynomial< Double > result[3], const Double coeff[3][6])
| The calcNNN() functions are helpers to initialize function scope static variables in the NNN() callers.
static void | calcPrecesCoef2000 (Polynomial< Double > result[3], const Double coeff[3][6])
static std::vector< Polynomial< Double > > | calcFundArg (const Double coeff[6][4])
| Calculate fundArg.
static std::vector< Polynomial< Double > > | calcFundArg00 (const Double coeff[6][5])
static std::vector< Polynomial< Double > > | calcPlanArg00 (const Double coeff[8][2])
static void | calcPlanetary (MeasJPL::Files *fil)
| Calculate planetary data.
static void | calcPlanetaryConstants (Double cn[MeasTable::N_JPLconst])
static std::vector< Polynomial< Double > > | calcAberArg ()
| Calculate aberration data.
static std::vector< Polynomial< Double > > | calcAberArgDeriv ()
static std::vector< Polynomial< Double > > | calcAber1950Arg ()
static std::vector< Polynomial< Double > > | calcAber1950ArgDeriv ()
static std::vector< Vector< Double > > | calcMulSunAber ()
static std::vector< Vector< Double > > | calcMulEarthAber ()
static std::vector< Vector< Double > > | calcAberETerm ()
static std::vector< Vector< Double > > | calcVelocityLSRK ()
| Calculate velocity data.
static std::vector< Vector< Double > > | calcVelocityLSR ()
static std::vector< Vector< Double > > | calcVelocityLSRGal ()
static std::vector< Vector< Double > > | calcVelocityLGROUP ()
static std::vector< Vector< Double > > | calcVelocityCMB ()
static std::vector< Polynomial< Double > > | calcPosArg ()
| Calculate Earth and Sun position data.
static std::vector< Polynomial< Double > > | calcPosArgDeriv ()
static RotMatrix | calcRectToPos ()
| Calculate some of the rotation matrices for coordinate conversion.
static RotMatrix | calcICRSToJ2000 ()
static Statics_dUTC | calc_dUTC ()
static Polynomial< Double > | calcGMST0 ()
static Polynomial< Double > | calcGMST00 ()
static Polynomial< Double > | calcERA00 ()
static Polynomial< Double > | calcGMUT0 ()
static Polynomial< Double > | calcUTtoST ()

## Static Private Attributes

static std::once_flag | theirPlanetaryInitOnceFlag
| Planetary table data.
static std::once_flag | theirPlanetaryConstantsInitOnceFlag
static MeasTableMulSC | theirMulSC
| Multipliers for nutation, etc.
static MeasTableMulSC1950 | theirMulSC1950
static MeasTableMulSC2000A | theirMulSC2000A
static MeasTableMulSC2000B | theirMulSC2000B
static MeasTableMulAber | theirMulAber
static MeasTableMulAber1950 | theirMulAber1950
static MeasTableMulPosSunXY | theirMulPosSunXY
static MeasTableMulPosSunZ | theirMulPosSunZ
static MeasTableMulPosEarthXY | theirMulPosEarthXY
static MeasTableMulPosEarthZ | theirMulPosEarthZ
static std::once_flag | theirObsInitOnceFlag
| Observatories table data.
static Vector< String > | obsNams
static Vector< MPosition > | obsPos
static Vector< String > | antResponsesPath
static std::once_flag | theirLinesInitOnceFlag
| Spectral line table data.
static Vector< String > | lineNams
static Vector< MFrequency > | linePos
static std::once_flag | theirSrcInitOnceFlag
| Sources table data.
static Vector< String > | srcNams
static Vector< MDirection > | srcPos
static std::once_flag | theirIGRFInitOnceFlag
| IGRF data.
static Double | dtimeIGRF
static Double | firstIGRF
static Double | lastIGRF
static Double | time0IGRF
static Double | timeIGRF
static std::vector< Vector< Double > > | coefIGRF
static std::vector< Vector< Double > > | dIGRF

## Detailed Description

MeasTable provides Measure computing database data

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMeasMath

### Prerequisite

- Measure class
- MeasData class for constant data
- Aipsrc class for data placement

### Etymology

MeasTable from Measure and Table

### Synopsis

MeasTable contains the database interface for all data necessary for precession, nutation and other Measure related calculations.
All data are obtained by calls to a method. E.g. fundArg(1) will provide the first fundamental argument for nutation calculations, i.e. 'l'.
This class contains no constructors or destructors, only static methods and (static) constants.
References:
Explanatory supplements to the Astronomical Almanac
C. Ron and J. Vondrak, Bull. Astron. Inst. Czechosl. 37, p96, 1986
M. Soma, Th. Hirayama and H. Kinoshita, Celest. Mech. 41, p389, 1988
V.S. Gubanov, Astron. Zh. 49, p1112, 1972

Where strings are passed in as arguments (observatory names, sources), they will be case insensitive, and minimum match.

### Example

Usage examples can be found in Precession

### Motivation

To create a clean interface between the actual calculations and the methods to obtain the parameters for these calculations. Note that the tables are in general in the format and units found in the literature. This is to be able to easy check and change them. However, in the future re-arrangement could produce faster and more compact code.

### To Do

- more database interfaces, rather than constants

Definition at line 101 of file MeasTable.h.

## Member Enumeration Documentation

## JPLconst

enum casacore::MeasTable::JPLconst

Codes for JPL constants: order should be same as in MeasJPL, length less than or equal.

Enumerator
CAU | Light velocity used in AU/d.
GMS | Solar mass (GM0)/c2 in AU.
AU | AU in km.
RADS | Solar radius in AU.

N_JPLconst

# of codes

Definition at line 133 of file MeasTable.h.

## Types

enum casacore::MeasTable::Types

Types to be used in different calls.

Enumerator
MERCURY | Planetary information.
VENUS |
EARTH |
MARS |
JUPITER |
SATURN |
URANUS |
NEPTUNE |
PLUTO |
MOON |
SUN |
BARYSOLAR | Solar system barycentre.
BARYEARTH | Earth-Moon system barycentre.
NUTATION | Nutations.
LIBRATION | Librations.
N_Types | Number of types.

Definition at line 107 of file MeasTable.h.

## Member Function Documentation

## aber1950Arg()

const Polynomial< Double > & casacore::MeasTable::aber1950Arg | ( | uInt | which | ) |

static

References casacore::Polynomial().

## aber1950ArgDeriv()

const Polynomial< Double > & casacore::MeasTable::aber1950ArgDeriv | ( | uInt | which | ) |

static

References casacore::Polynomial().

## aberArg()

const Polynomial< Double > & casacore::MeasTable::aberArg | ( | uInt | which | ) |

static

Aberration related data.

Generate the polynomial for the fundamental arguments (l1-l8, w, D, l, l', F) for the Ron/Vondrak aberration calculations as a function of Julian centuries(J2000), or the comparable ones for the Gubanov expansion (B1950).

References casacore::Polynomial().

## aberArgDeriv()

const Polynomial< Double > & casacore::MeasTable::aberArgDeriv | ( | uInt | which | ) |

static

References casacore::Polynomial().

## AberETerm()

const Vector< Double > & casacore::MeasTable::AberETerm | ( | uInt | which | ) |

static

Get the E-terms of Aberration correction (0 for position, 1 for velocity).

## AntennaResponsesPath()

Bool casacore::MeasTable::AntennaResponsesPath | ( | String & | antRespPath,
|  | const String & | nam )

static

Get absolute path to AntennaResponses table of observatory nam.

It returns False if no valid path can be found or the observatory is unknown. If the observatory is known, antRespPath will be set to the entry in the AntennaResponses column of the Observatories table even if it doesn't describe a valid path; if the entry is not an absolute path, the data directory name will be prepended and validity verified.

## calc_dUTC()

Statics_dUTC casacore::MeasTable::calc_dUTC | ( |  | ) |

static private

## calcAber1950Arg()

std::vector< Polynomial< Double > > casacore::MeasTable::calcAber1950Arg | ( |  | ) |

static private

## calcAber1950ArgDeriv()

std::vector< Polynomial< Double > > casacore::MeasTable::calcAber1950ArgDeriv | ( |  | ) |

static private

## calcAberArg()

std::vector< Polynomial< Double > > casacore::MeasTable::calcAberArg | ( |  | ) |

static private

Calculate aberration data.

## calcAberArgDeriv()

std::vector< Polynomial< Double > > casacore::MeasTable::calcAberArgDeriv | ( |  | ) |

static private

## calcAberETerm()

std::vector< Vector< Double > > casacore::MeasTable::calcAberETerm | ( |  | ) |

static private

## calcERA00()

Polynomial< Double > casacore::MeasTable::calcERA00 | ( |  | ) |

static private

References casacore::Polynomial().

## calcFundArg()

std::vector< Polynomial< Double > > casacore::MeasTable::calcFundArg | ( | const Double | coeff[6][4] | ) |

static private

Calculate fundArg.

## calcFundArg00()

std::vector< Polynomial< Double > > casacore::MeasTable::calcFundArg00 | ( | const Double | coeff[6][5] | ) |

static private

## calcGMST0()

Polynomial< Double > casacore::MeasTable::calcGMST0 | ( |  | ) |

static private

References casacore::Polynomial().

## calcGMST00()

Polynomial< Double > casacore::MeasTable::calcGMST00 | ( |  | ) |

static private

References casacore::Polynomial().

## calcGMUT0()

Polynomial< Double > casacore::MeasTable::calcGMUT0 | ( |  | ) |

static private

References casacore::Polynomial().

## calcICRSToJ2000()

RotMatrix casacore::MeasTable::calcICRSToJ2000 | ( |  | ) |

static private

## calcMulEarthAber()

std::vector< Vector< Double > > casacore::MeasTable::calcMulEarthAber | ( |  | ) |

static private

## calcMulSunAber()

std::vector< Vector< Double > > casacore::MeasTable::calcMulSunAber | ( |  | ) |

static private

## calcPlanArg00()

std::vector< Polynomial< Double > > casacore::MeasTable::calcPlanArg00 | ( | const Double | coeff[8][2] | ) |

static private

## calcPlanetary()

void casacore::MeasTable::calcPlanetary | ( | MeasJPL::Files * | fil | ) |

static private

Calculate planetary data.

## calcPlanetaryConstants()

void casacore::MeasTable::calcPlanetaryConstants | ( | Double | cn[MeasTable::N_JPLconst] | ) |

static private

References N_JPLconst.

## calcPosArg()

std::vector< Polynomial< Double > > casacore::MeasTable::calcPosArg | ( |  | ) |

static private

Calculate Earth and Sun position data.

## calcPosArgDeriv()

std::vector< Polynomial< Double > > casacore::MeasTable::calcPosArgDeriv | ( |  | ) |

static private

## calcPrecesCoef()

void casacore::MeasTable::calcPrecesCoef | ( | Double | T,
|  | Polynomial< Double > | result[3],
|  | const Double | coeff[3][6] )

static private

The calcNNN() functions are helpers to initialize function scope static variables in the NNN() callers.

Calculate precessionCoef

References casacore::Polynomial().

## calcPrecesCoef2000()

void casacore::MeasTable::calcPrecesCoef2000 | ( | Polynomial< Double > | result[3],
|  | const Double | coeff[3][6] )

static private

References casacore::Polynomial().

## calcRectToPos()

RotMatrix casacore::MeasTable::calcRectToPos | ( |  | ) |

static private

Calculate some of the rotation matrices for coordinate conversion.

## calcUTtoST()

Polynomial< Double > casacore::MeasTable::calcUTtoST | ( |  | ) |

static private

References casacore::Polynomial().

## calcVelocityCMB()

std::vector< Vector< Double > > casacore::MeasTable::calcVelocityCMB | ( |  | ) |

static private

## calcVelocityLGROUP()

std::vector< Vector< Double > > casacore::MeasTable::calcVelocityLGROUP | ( |  | ) |

static private

## calcVelocityLSR()

std::vector< Vector< Double > > casacore::MeasTable::calcVelocityLSR | ( |  | ) |

static private

## calcVelocityLSRGal()

std::vector< Vector< Double > > casacore::MeasTable::calcVelocityLSRGal | ( |  | ) |

static private

## calcVelocityLSRK()

std::vector< Vector< Double > > casacore::MeasTable::calcVelocityLSRK | ( |  | ) |

static private

Calculate velocity data.

## diurnalAber()

Double casacore::MeasTable::diurnalAber | ( | Double | radius,
|  | Double | T )

static

Diurnal aberration factor.

## doInitIGRF()

void casacore::MeasTable::doInitIGRF | ( |  | ) |

static private

## doInitLines()

void casacore::MeasTable::doInitLines | ( |  | ) |

static private

## doInitObservatories()

void casacore::MeasTable::doInitObservatories | ( |  | ) |

static private

## doInitSources()

void casacore::MeasTable::doInitSources | ( |  | ) |

static private

## dPsiEps()

Double casacore::MeasTable::dPsiEps | ( | uInt | which,
|  | Double | T )

static

Get nutation angles corrections for UTC T in rad.

which = 0 : dPsi as given by IERS for IAU nutation theory; = 1: dEps as same.

## dTAI()

Double casacore::MeasTable::dTAI | ( | Double | tai = 0.0 | ) |

static

TDT-TAI (in s) for MJD tai TAI.

Note this is equal to TT2000-TAI

## dTCG()

Double casacore::MeasTable::dTCG | ( | Double | tai | ) |

static

TCG-TT (in s) for MJD tai TAI.

## dTDB()

Double casacore::MeasTable::dTDB | ( | Double | tai | ) |

static

TCB-TDB (in s) for MJD tai TAI.

## dTDT()

Double casacore::MeasTable::dTDT | ( | Double | ut1 | ) |

static

TDB-TDT (in s) for MJD ut1 UT1.

## dUT1()

Double casacore::MeasTable::dUT1 | ( | Double | utc | ) |

static

UT1-UTC (in s) for MJD tai TAI.

## dUTC()

Double casacore::MeasTable::dUTC | ( | Double | utc | ) |

static

Time related routines
Note: WARNING given if correction not obtainable
.

### Thrown Exceptions

- AipsError if table seems to be corrupted

Give TAI-UTC (in s) for MJD utc UTC

## ERA00()

Double casacore::MeasTable::ERA00 | ( | Double | ut1 | ) |

static

Earth Rotation Angle (IAU2000) in rad.

## frameBias00()

RotMatrix casacore::MeasTable::frameBias00 | ( |  | ) |

static

Get the frame bias matrix for IAU2000 model.

## fundArg()

const Polynomial< Double > & casacore::MeasTable::fundArg | ( | uInt | which | ) |

static

Nutation related data.

Generate the polynomial for the fundamental arguments (eps, l, l', F, D, omega) as a function of Julian centuries

References casacore::Polynomial().

## fundArg1950()

const Polynomial< Double > & casacore::MeasTable::fundArg1950 | ( | uInt | which | ) |

static

References casacore::Polynomial().

## fundArg2000()

const Polynomial< Double > & casacore::MeasTable::fundArg2000 | ( | uInt | which | ) |

static

References casacore::Polynomial().

## galToSupergal()

const RotMatrix & casacore::MeasTable::galToSupergal | ( |  | ) |

static

Get the rotation matrix from galactic to supergalactic.

Based on De Vaucouleurs 1976: Pole at 47.37/6.32 deg; 137.37 l0 Euler angles: 90, 83.68, 47.37 degrees

## GMST0()

Double casacore::MeasTable::GMST0 | ( | Double | ut1 | ) |

static

GMST1 at MJD ut1 UT1.

## GMST00()

Double casacore::MeasTable::GMST00 | ( | Double | ut1,
|  | Double | tt )

static

GMST (IAU2000) including the ERA (IAU2000 Earth Rotation Angle) in rad.

## GMUT0()

Double casacore::MeasTable::GMUT0 | ( | Double | gmst1 | ) |

static

UT1 at GMSD gmst1 GMST1.

## ICRSToJ2000()

const RotMatrix & casacore::MeasTable::ICRSToJ2000 | ( |  | ) |

static

Get the rotation matrix from ICRS to J2000/FK5.

Based on the IAU 2000 resolutions (the bias matrix)

## IGRF()

Vector< Double > casacore::MeasTable::IGRF | ( | Double | t | ) |

static

Earth magnetic field (IGRF) data Get the harmonic terms for specified time (mjd).

## initIGRF()

void casacore::MeasTable::initIGRF | ( |  | ) |

static

Initialise list of IGRF data Called using theirIGRFInitOnce.

## initLines()

void casacore::MeasTable::initLines | ( |  | ) |

static

Rest frequencies.

Initialise list from internal Table for now Called using theirLinesInitOnce.

## initObservatories()

void casacore::MeasTable::initObservatories | ( |  | ) |

static

Observatory positions.

Initialise list of all observatories from Observatories table Called using theirObsInitOnce.

## initSources()

void casacore::MeasTable::initSources | ( |  | ) |

static

Source list positions.

Initialise list of all source from Sources table Called using theirSrcInitOnce.

## Line()

Bool casacore::MeasTable::Line | ( | MFrequency & | obs,
|  | const String & | nam )

static

Get frequency of line name (False if not present).

## Lines()

const Vector< String > & casacore::MeasTable::Lines | ( |  | ) |

static

Get list of all frequencies.

## mulAber()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulAber | ( | Double | time,
|  | Double | epsilon )

static

Generate the 'which' vector of the aberration series multipliers at T, measured in Julian centuries since J2000.0 (or J1900.0, yes, J1900.0, for B1950).

References casacore::time().

## mulAber1950()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulAber1950 | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulAber1950Arg()

const Double * casacore::MeasTable::mulAber1950Arg | ( | uInt | which | ) |

static

## mulAberArg()

const Double * casacore::MeasTable::mulAberArg | ( | uInt | which | ) |

static

Generate the 'which' vector of the aberration series arguments.

## mulAberEarthArg()

const Double * casacore::MeasTable::mulAberEarthArg | ( | uInt | which | ) |

static

## mulAberSunArg()

const Double * casacore::MeasTable::mulAberSunArg | ( | uInt | which | ) |

static

## mulArg()

const Double * casacore::MeasTable::mulArg | ( | uInt | which | ) |

static

Generate the which' vector of the nutation series arguments.

## mulArg1950()

const Double * casacore::MeasTable::mulArg1950 | ( | uInt | which | ) |

static

## mulArg2000A()

const Double * casacore::MeasTable::mulArg2000A | ( | uInt | which | ) |

static

## mulArg2000B()

const Double * casacore::MeasTable::mulArg2000B | ( | uInt | which | ) |

static

## mulArgEqEqCT2000()

const Double * casacore::MeasTable::mulArgEqEqCT2000 | ( | uInt | which | ) |

static

Generate the which' vector of the equation of equinoxes (IAU2000) complementary terms series arguments.

## mulEarthAber()

const Vector< Double > & casacore::MeasTable::mulEarthAber | ( | uInt | which | ) |

static

## mulPlanArg2000A()

const Double * casacore::MeasTable::mulPlanArg2000A | ( | uInt | which | ) |

static

## mulPlanSC2000A()

const Double * casacore::MeasTable::mulPlanSC2000A | ( | uInt | which | ) |

static

## mulPosEarthXY()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulPosEarthXY | ( | Double | time,
|  | Double | epsilon )

static

Generate the which' vector of the position series multipliers at T, measured in Julian centuries since J2000.0.

References casacore::time().

## mulPosEarthXYArg()

const Double * casacore::MeasTable::mulPosEarthXYArg | ( | uInt | which | ) |

static

Generate the which' vector of the position series arguments.

## mulPosEarthZ()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulPosEarthZ | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulPosEarthZArg()

const Double * casacore::MeasTable::mulPosEarthZArg | ( | uInt | which | ) |

static

## mulPosSunXY()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulPosSunXY | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulPosSunXYArg()

const Double * casacore::MeasTable::mulPosSunXYArg | ( | uInt | which | ) |

static

## mulPosSunZ()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulPosSunZ | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulPosSunZArg()

const Double * casacore::MeasTable::mulPosSunZArg | ( | uInt | which | ) |

static

## mulSC()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulSC | ( | Double | time,
|  | Double | epsilon )

static

Generate the which' vector of the nutation series multipliers at T, measured in Julian centuries since J2000.0, respectively B1900.0.

References casacore::time().

## mulSC1950()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulSC1950 | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulSC2000A()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulSC2000A | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulSC2000B()

std::shared_ptr< Matrix< Double > > casacore::MeasTable::mulSC2000B | ( | Double | time,
|  | Double | epsilon )

static

References casacore::time().

## mulSCEqEqCT2000()

const Double * casacore::MeasTable::mulSCEqEqCT2000 | ( | uInt | which | ) |

static

Generate the which' vector of the equation of equinoxes (IAU2000) complementary terms series multipliers at T, measured in Julian centuries since J2000.0, respectively B1900.0.

## mulSunAber()

const Vector< Double > & casacore::MeasTable::mulSunAber | ( | uInt | which | ) |

static

## Observatories()

const Vector< String > & casacore::MeasTable::Observatories | ( |  | ) |

static

Get list of all observatories.

## Observatory()

Bool casacore::MeasTable::Observatory | ( | MPosition & | obs,
|  | const String & | nam )

static

Get position of observatory nam (False if not present).

## operator=()

MeasTable & casacore::MeasTable::operator= | ( | const MeasTable & | other | ) |

private

Copy assign, NOT defined.

## Planetary() [1/2]

Double casacore::MeasTable::Planetary | ( | MeasTable::JPLconst | what | ) |

static

Get the JPL DE constant indicated.

## Planetary() [2/2]

Vector< Double > casacore::MeasTable::Planetary | ( | MeasTable::Types | which,
|  | Double | T )

static

Planetary (JPL DE) related data.

Get the position (AU or rad) and velocity (AU/d or rad/d) for specified code at TDB T. The ephemeris to use (now DE200 or DE405) can be selected with the 'measures.jpl.ephemeris' aipsrc resource (default DE200).

## planetaryArg2000()

const Polynomial< Double > & casacore::MeasTable::planetaryArg2000 | ( | uInt | which | ) |

static

Get the planetary arguments (L, L', F, D, Om, Me, Ve, E, Ma, Ju Sa, Ur, Ne, pre).

References casacore::Polynomial().

## polarMotion()

Euler casacore::MeasTable::polarMotion | ( | Double | ut | ) |

static

Polar motion related routines.

Get the polar motion (-x,-y,0)(2,1,3) angles at the given epoch

## posArg()

const Polynomial< Double > & casacore::MeasTable::posArg | ( | uInt | which | ) |

static

Earth and Sun position related data.

Fundamental arguments for Soma et al. methods

References casacore::Polynomial().

## posArgDeriv()

const Polynomial< Double > & casacore::MeasTable::posArgDeriv | ( | uInt | which | ) |

static

Precomputed derivative of PosArg.

References casacore::Polynomial().

## posToRect()

const RotMatrix & casacore::MeasTable::posToRect | ( |  | ) |

static

Get the rotation matrix to change position from ecliptic to rectangular for Soma et al.

analytical expression

## precessionCoef()

void casacore::MeasTable::precessionCoef | ( | Double | T,
|  | Polynomial< Double > | result[3] )

static

Generate the precession calculation polynomials for a fixed Epoch T in the result area specified.

T is given in Julian centuries since J2000.0.

References casacore::Polynomial().

## precessionCoef1950()

void casacore::MeasTable::precessionCoef1950 | ( | Double | T,
|  | Polynomial< Double > | result[3] )

static

Generate the precession polynomials for 1950 system for a fixed Epoch T in the area specified.

T is given in Tropical centuries since B1850.0

References casacore::Polynomial().

## precessionCoef2000()

void casacore::MeasTable::precessionCoef2000 | ( | Polynomial< Double > | result[3] | ) |

static

Generate the precession polynomials for IAU2000 system.

References casacore::Polynomial().

## precRate00()

Double casacore::MeasTable::precRate00 | ( | const uInt | which | ) |

static

Precession related data.

Get the precession-rate part of the IAU2000 precession-nutation models (which 0=dpsi (long) and 1=deps (obliquity) and 2 =0)

## rectToPos()

const RotMatrix & casacore::MeasTable::rectToPos | ( |  | ) |

static

Get the rotation matrix to change position from rectangular to ecliptic for Soma et al.

analytical expression

## Source()

Bool casacore::MeasTable::Source | ( | MDirection & | obs,
|  | const String & | nam )

static

Get position of source nam (False if not present).

## Sources()

const Vector< String > & casacore::MeasTable::Sources | ( |  | ) |

static

Get list of all sources.

## sprime00()

Double casacore::MeasTable::sprime00 | ( | Double | tt | ) |

static

s' (IAU2000) in rad (approximate value)

## useIAU2000()

Bool casacore::MeasTable::useIAU2000 | ( |  | ) |

static

Selection related data.

Are the IAU2000 precession/nutation to be used or not (IAU1984) Note that an Aipsrc::reRead() is not reflected in the return value here.

## useIAU2000A()

Bool casacore::MeasTable::useIAU2000A | ( |  | ) |

static

If IAU2000 model, do we use the high precision 2000A model?

Note that an Aipsrc::reRead() is not reflected in the return value here.

## UTtoST()

Double casacore::MeasTable::UTtoST | ( | Double | ut1 | ) |

static

Ratio UT1/MST at MJD ut1 UT1.

## velocityCMB()

const Vector< Double > & casacore::MeasTable::velocityCMB | ( | uInt | which | ) |

static

Velocity of Local Group wrt bary center (F.Ghigo): 308km/s towards l,b = 105,-7.

0 for J2000, 1 for B1950

## velocityLGROUP()

const Vector< Double > & casacore::MeasTable::velocityLGROUP | ( | uInt | which | ) |

static

Velocity of CMB wrt bary center (F.Ghigo): 369.5km/s towards l,b = 264.4,48.4.

0 for J2000, 1 for B1950

## velocityLSR()

const Vector< Double > & casacore::MeasTable::velocityLSR | ( | uInt | which | ) |

static

LSR (dynamical, IAU definition).

Velocity (9,12,7) km/s in galactic coordinates. Or 16.552945 towards l,b = 53.13, +25.02 deg. 0 gives J2000, 1 gives B1950 velocities.

## velocityLSRGal()

const Vector< Double > & casacore::MeasTable::velocityLSRGal | ( | uInt | which | ) |

static

Velocity of LSR with respect to galactic centre.

220 km/s in direction l,b = 270, +0 deg. 0 returns J2000, 1 B1950

## velocityLSRK()

const Vector< Double > & casacore::MeasTable::velocityLSRK | ( | uInt | which | ) |

static

LSR (kinematical) velocity conversion: 0 gives J2000; 1 gives B1950.

In both cases a velocity of 20.0 km/s is assumed, and a B1900 RA/Dec direction of (270,30) degrees. This value has been defined between the groups doing HI radio work in the mid 1950s.

## WGS84()

Double casacore::MeasTable::WGS84 | ( | uInt | which | ) |

static

Position related routines.

Equatorial radius (0) and flattening(1) of geodetic reference spheroids

## Member Data Documentation

## antResponsesPath

Vector<String> casacore::MeasTable::antResponsesPath

static private

Definition at line 544 of file MeasTable.h.

## coefIGRF

std::vector<Vector<Double> > casacore::MeasTable::coefIGRF

static private

Definition at line 566 of file MeasTable.h.

## dIGRF

std::vector<Vector<Double> > casacore::MeasTable::dIGRF

static private

Definition at line 567 of file MeasTable.h.

## dtimeIGRF

Double casacore::MeasTable::dtimeIGRF

static private

Definition at line 561 of file MeasTable.h.

## firstIGRF

Double casacore::MeasTable::firstIGRF

static private

Definition at line 562 of file MeasTable.h.

## lastIGRF

Double casacore::MeasTable::lastIGRF

static private

Definition at line 563 of file MeasTable.h.

## lineNams

Vector<String> casacore::MeasTable::lineNams

static private

Definition at line 549 of file MeasTable.h.

## linePos

Vector<MFrequency> casacore::MeasTable::linePos

static private

Definition at line 550 of file MeasTable.h.

## obsNams

Vector<String> casacore::MeasTable::obsNams

static private

Definition at line 542 of file MeasTable.h.

## obsPos

Vector<MPosition> casacore::MeasTable::obsPos

static private

Definition at line 543 of file MeasTable.h.

## srcNams

Vector<String> casacore::MeasTable::srcNams

static private

Definition at line 555 of file MeasTable.h.

## srcPos

Vector<MDirection> casacore::MeasTable::srcPos

static private

Definition at line 556 of file MeasTable.h.

## theirIGRFInitOnceFlag

std::once_flag casacore::MeasTable::theirIGRFInitOnceFlag

static private

IGRF data.

Definition at line 560 of file MeasTable.h.

## theirLinesInitOnceFlag

std::once_flag casacore::MeasTable::theirLinesInitOnceFlag

static private

Spectral line table data.

Definition at line 548 of file MeasTable.h.

## theirMulAber

MeasTableMulAber casacore::MeasTable::theirMulAber

static private

Definition at line 531 of file MeasTable.h.

## theirMulAber1950

MeasTableMulAber1950 casacore::MeasTable::theirMulAber1950

static private

Definition at line 532 of file MeasTable.h.

## theirMulPosEarthXY

MeasTableMulPosEarthXY casacore::MeasTable::theirMulPosEarthXY

static private

Definition at line 535 of file MeasTable.h.

## theirMulPosEarthZ

MeasTableMulPosEarthZ casacore::MeasTable::theirMulPosEarthZ

static private

Definition at line 536 of file MeasTable.h.

## theirMulPosSunXY

MeasTableMulPosSunXY casacore::MeasTable::theirMulPosSunXY

static private

Definition at line 533 of file MeasTable.h.

## theirMulPosSunZ

MeasTableMulPosSunZ casacore::MeasTable::theirMulPosSunZ

static private

Definition at line 534 of file MeasTable.h.

## theirMulSC

MeasTableMulSC casacore::MeasTable::theirMulSC

static private

Multipliers for nutation, etc.

Definition at line 527 of file MeasTable.h.

## theirMulSC1950

MeasTableMulSC1950 casacore::MeasTable::theirMulSC1950

static private

Definition at line 528 of file MeasTable.h.

## theirMulSC2000A

MeasTableMulSC2000A casacore::MeasTable::theirMulSC2000A

static private

Definition at line 529 of file MeasTable.h.

## theirMulSC2000B

MeasTableMulSC2000B casacore::MeasTable::theirMulSC2000B

static private

Definition at line 530 of file MeasTable.h.

## theirObsInitOnceFlag

std::once_flag casacore::MeasTable::theirObsInitOnceFlag

static private

Observatories table data.

Definition at line 541 of file MeasTable.h.

## theirPlanetaryConstantsInitOnceFlag

std::once_flag casacore::MeasTable::theirPlanetaryConstantsInitOnceFlag

static private

Definition at line 522 of file MeasTable.h.

## theirPlanetaryInitOnceFlag

std::once_flag casacore::MeasTable::theirPlanetaryInitOnceFlag

static private

Planetary table data.

Definition at line 521 of file MeasTable.h.

## theirSrcInitOnceFlag

std::once_flag casacore::MeasTable::theirSrcInitOnceFlag

static private

Sources table data.

Definition at line 554 of file MeasTable.h.

## time0IGRF

Double casacore::MeasTable::time0IGRF

static private

Definition at line 564 of file MeasTable.h.

## timeIGRF

Double casacore::MeasTable::timeIGRF

static private

Definition at line 565 of file MeasTable.h.

The documentation for this class was generated from the following file:

- measures/Measures/MeasTable.h